
#include <classes/BOOPSI/gadgetclass.h>

#pragma -
#include <pragma/intuition_lib.h>
#pragma +

BGadgetC::BGadgetC(GadgetEventC *ev, struct IClass *c,
		STRPTR pubclass, WindowC &w,struct TagItem *tattr)
	: BoopsiRootC(c,pubclass,tattr), GadgetC(ev)
{
	bWindow = &w;
	gadget_ob = (struct Gadget *) boopsi_object;
	setAttrs(GA_UserData,(GadgetC *) this,TAG_END);
}

BGadgetC::BGadgetC(GadgetEventC *ev, struct IClass *c,
		STRPTR pubclass, WindowC &w, Tag tag1type, ...)
	: BoopsiRootC(c,pubclass,(struct TagItem *) &tag1type), GadgetC(ev)
{
	bWindow = &w;
	gadget_ob = (struct Gadget *) boopsi_object;
	setAttrs(GA_UserData,(GadgetC *) this,TAG_END);
}

VOID BGadgetC::setAttrs(Tag tag1type, ...)
{
	setAttrs((struct TagItem *) &tag1type);
}

VOID BGadgetC::setAttrs(struct TagItem *tattr)
{
	if (bWindow->window())
		SetGadgetAttrsA((struct Gadget *) boopsi_object,
			bWindow->window(),NULL,tattr);
	else
		SetAttrsA((APTR) boopsi_object,tattr);
}

struct Gadget *BGadgetC::rebuild(struct Gadget *prev)
{
	if (prev)
	{
		prev->NextGadget = (struct Gadget *) boopsi_object;
		return (struct Gadget *) boopsi_object;
	};
	return NULL;
}

BOOL BGadgetC::disable(BOOL value)
{
	setAttrs(GA_Disabled,value,TAG_END);
	refresh(bWindow);
	return TRUE;
}

BOOL BGadgetC::isDisabled() const
{
	return (((struct Gadget *) boopsi_object)->Flags & GFLG_DISABLED) != 0;
}

